;;;; wh-engine system definition
;;;; Copyleft (C) 2021 ~keith

(defsystem "wh-engine"
  :version "0.1.0"
  :description "A game engine written in Common Lisp."
  :author "~keith"
  :license "GNU AGPLv3"
  :depends-on ("sdl2" "cl-opengl" "trivial-types" "objective-lisp" "3d-vectors" "3d-matrices")
  :components
  ((:module "wh-engine"
    :components ((:file "package")
                 (:file "global")
                 (:file "actor")
                 (:file "component")
                 (:file "actor-macros")
                 (:file "scene")
                 (:file "serialization")
                 (:file "systems")
                 (:file "render/render-system")
                 (:file "render/shader")
                 (:file "render/drawable")
                 (:file "render/render-target")
                 (:file "render/view")
                 (:file "input/input-system")
                 (:file "main"))
    )))
